﻿''' <summary>
''' マウスカーソルからの逃避行 ～ 派生クラス：『画面中央の右往左往』編
''' </summary>
''' <remarks>画面中央の左右を行き来する。</remarks>
Public Class Avoid_ScreenSide

    Inherits Avoid_Base



    '===========================================================================================================



    ''' <summary>水平方向のマージン</summary>
    Private HorizonMargin As Integer



    '===========================================================================================================



    ''' <summary>
    ''' インスタンスの初期化
    ''' </summary>
    ''' <param name="Viewer">ビューア</param>
    ''' <remarks></remarks>
    Public Sub New(Viewer As FormMain_Viewer)

        MyBase.New(Viewer)

    End Sub

    Public Overrides Sub Initialize(WorkArea As Rectangle)

        '=== 初期値設定 ===
        With WorkArea

            AvoidSpeed = INITIAL_SPEED
            AvoidExerciseDistance = Math.Min(.Width, .Height) / 100 * SettingData.Lupe.Avoid.ExerciseDistance '回避発動距離は、画面の縦横の短い方を基準として算出。

            '--- 許容範囲 ---
            HorizonMargin = Owner.Width + AvoidExerciseDistance

            '--- とりあえずの表示位置 ---
            AvoidDestination.X = If(.Left + (.Width - Owner.Width) / 2 > Owner.Left, .Left, .Right - Owner.Width) '左右のどちらか近い方。
            AvoidDestination.Y = .Top + (.Height - Owner.Height) \ 2 '中央

        End With

    End Sub

    Protected Overrides Sub Plan(WorkArea As Rectangle)

        Dim newLocate As Point = AvoidDestination '新しい目的地
        Dim mousePosition As Point = Windows.Forms.Cursor.Position 'マウスカーソルの位置

        '=== 目的地 ===
        With WorkArea

            If mousePosition.X < .Left + HorizonMargin Then
                newLocate.X = .Right - Owner.Width '画面右側へ
            ElseIf mousePosition.X > .Right - HorizonMargin Then
                newLocate.X = .Left '画面左側へ
            End If

        End With

        '=== 目的地変更 ===
        If AvoidDestination <> newLocate Then
            AvoidDestination = newLocate
            AvoidSpeed = INITIAL_SPEED
        End If

    End Sub

End Class
