﻿'┌────┐
'│技術要綱├──────────────────────
'└┬───┘
'  │『理解不足』
'  │●列挙型や構造体は特殊なクラスだから、クラスやモジュールの外側に記述しても構わないということなのかな？
'  │●2つある《Enum》を《Module》内に置くと設定パラメータで「外部に公開できない」と言われる。なんでエラーが出るの？
'  │→とりあえず、名前空間で囲んで、プロジェクトにインポートしておいた。
'  │
'  │『どこに記述するべきか』
'  │これらの列挙型は、どこに記述するのが良いのだろうか？
'  │それぞれが関係する基底クラスに書くような気もするけど、そうすると派生クラスにも同じものができちゃってややこしい。
'  │ここのように独立して書いちゃうのも、だれが提供している物なのか、何に使うための物なのかが不明瞭な気もする。
'  │ましてや、形式パターンを格納する構造体は、特定のクラスで使用するだけの物ではないから、ますますどこに記述するべきなのかわからなくなる。
'  └────────────





Namespace CompanionCollection

    ''' <summary>
    ''' 情報パネルの形態
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum InfoPanelStyles As Byte

        ''' <summary>非表示</summary>
        Unvisible

        ''' <summary>みたらし団子</summary>
        Full

        ''' <summary>若あゆ</summary>
        Bar

        ''' <summary>きんつば</summary>
        Square

        ''' <summary>八つ橋</summary>
        Twig

        ''' <summary>五色豆</summary>
        Mini

    End Enum

    ''' <summary>
    ''' マウスカーソルからの回避方法
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum AvoidActionTypes As Byte

        ''' <summary>手取り足取り（通常のウィンドウと同じ）</summary>
        Passive

        ''' <summary>画面中央の右往左往</summary>
        ScreenSide

        ''' <summary>画面右の三角関係</summary>
        RightTriangle

        ''' <summary>画面四隅のすれ違い</summary>
        ScreenCorner

        ''' <summary>画面の中の金魚</summary>
        Randezvous

    End Enum



    '===========================================================================================================



    ''' <summary>
    ''' 形式パターン
    ''' </summary>
    ''' <typeparam name="T">ジェネリックの型パラメータ</typeparam>
    ''' <remarks></remarks>
    Public Structure PatternItem(Of T)

        ''' <summary>呼称</summary>
        Public Property Caption As String

        ''' <summary>形式</summary>
        Public Property TypeID As T

    End Structure

End Namespace
