﻿'[FormMain_Viewer]クラスの続き
'コマンドの実行に係わるルーチンをまとまる。

Partial Class FormMain_Viewer

    ''' <summary>コマンド完了音</summary>
    Private Const SIGNAL_COMPLETE As String = "complete.wav" 'ダイレクトキーからも使用される。


    '-----------------------------------------------------------------------------------------------------------


    Private Sub FrmCommandPad_Action(sender As Object, e As CommandEventArgs) Handles frmCommandPad.Action

        Dim errorMessage As String = "" 'エラーメッセージ

        Select Case e.Request

            Case CommandEventArgs.Requests.SetCardinalPoint

                '=== 現在の基点として登録する ===
                ResumeData.CardinalPoint = ShootingLocation

            Case CommandEventArgs.Requests.GotoCardinalPoint, CommandEventArgs.Requests.GotoHome

                '=== マウスカーソルを基点や起点（使用画面の左上隅）へ移動する ===
                frmCommandPad.Visible = False 'コマンドパッドを一旦閉じる。→ マウスカーソルの移動範囲規制を解除する / ビューアの強制更新時にキャプチャ画像に写らないようにする / 新しいマウスカーソル位置にコマンドパッドを再表示させる。

                '--- 強制移動 ---
                Windows.Forms.Cursor.Position = If(e.Request = CommandEventArgs.Requests.GotoCardinalPoint, ResumeData.CardinalPoint, Screen.GetBounds(MousePosition).Location)

                '--- ビューアの強制更新 ---
                If AvoidPlanner IsNot Nothing AndAlso SetBasisParameter() Then '画面間をまたいだ場合に備えて、使用画面の作業領域サイズを調査する。
                    MakeViewer()
                    AvoidPlanner.Initialize(UsingScreen)
                End If
                RefreshLupe()

            Case CommandEventArgs.Requests.GetColor

                '=== 色コードをクリップボードへコピーする ===
                Try
                    'Throw New Exception("テスト") 'テスト用にエラーを発生させてみる。
                    Clipboard.SetText(GetColorString(GetLocationColor, SettingData.CommandPad.ColorFormat.Using))
                Catch ex As Exception
                    errorMessage = "色コードのコピーに失敗しました。" & vbCrLf & vbCrLf & ex.Message
                End Try

            Case CommandEventArgs.Requests.SendRGB

                '=== RGB送出 ===
                Try

                    '--- キーストロークのパターン変換 ---
                    '《SettingData.CommandPad.SendFormat》は以下の2種類に対応できると便利であろが、どちらも最終的に《String.Format》メソッドに通さなければならないので、それに適した形に変換する必要がある。
                    '・《String.Format》メソッド用に記述した直接的パターン                       例"^a{4}{{TAB}}^a{5}{{TAB}}^a{6}"       →  多様な数値出力が可能な代わりにキーストロークの記述が面倒になる（波括弧を二重にしなければならない）。
                    '・簡易置換マーカーを使用して《SendKeys》メソッド用に記述した間接的パターン  例"^a|RED|{TAB}^a|GREEN|{TAB}^a|BLUE|"  →  数値を10進数RGBに固定化する代わりにキーストローク部分は素直に書ける。
                    'そこで、正規表現の力を借りて間接的パターンを直接的パターンに変換する。

                    'Dim pattern As String = System.Text.RegularExpressions.Regex.Replace(SettingData.CommandPad.SendPattern, "\{[^0-9{].*?\}", "{$0}") '1."{キー名称}"を"{{キー名称}}"（二重括弧）に変換する。
                    'pattern = System.Text.RegularExpressions.Regex.Replace(pattern, "\{\{\{(?<key>[^0-9{].*?)\}\}\}", "{{${key}}}")               '2.作業1の副作用で、"{{キー名称}}"が"{{{キー名称}}}"（三重化）してしまっているので、"{{キー名称}}"に戻す。
                    '※結果的に、直接的パターンに一重波括弧でキーを記述しても適切に変換される。その反面、三重以上の波括弧が記述されている場合や、変換過程で三重以上になってしまった場合は不都合になる。
                    '※本来なら、「一重の"{～}"のみ捉える」正規表現が書ければ、もっとスマートで完璧になるんだけど、そんなパターン皆目見当がつかない。

                    Dim pattern As String = System.Text.RegularExpressions.Regex.Replace(SettingData.CommandPad.SendPattern, "(?<!{)\{(?<key>[^0-9{].*?)\}", "{{${key}}}") '"{キー名称}"（一重波括弧のみ）を"{{キー名称}}"（二重波括弧）に変換する。
                    '上記の二段階置換処理の問題点だった『「一重の"{～}"のみ捉える」正規表現を書けたなら』が実現できた！ たぶん、これで良いんだと思うんだけど…。
                    '中身 = 「前に始波括弧がない始波括弧 "(?<!{)\{"」「"key"名でグループ化 "(?<key>～)"」「数字と始波括弧以外で始まって "[^0-9{]"」「終波括弧で終わる最短マッチの文字列 "[^0-9{].*?\}"」
                    '       「"key"名でグループ化した文字列を二重波括弧で挟む "{{${key}}}"」

                    '--- 色要素置換 ---
                    pattern = pattern.Replace("|ALPHA|", "{3}").Replace("|RED|", "{4}").Replace("|GREEN|", "{5}").Replace("|BLUE|", "{6}") '簡易置換マーカーを《String.Format》メソッド用の書式に置き換える。
#If DEBUG Then
                    Console.Write(pattern) 'デバッグ：変換したパターンを出力する。
                    pattern = GetColorString(GetLocationColor, pattern)
                    Console.WriteLine(" => " & pattern) 'デバッグ：完成したパターンを出力する。
#Else
                    pattern = GetColorString(GetLocationColor, pattern)
#End If

                    '--- 送信 ---
                    SendKeys.SendWait(pattern)

                Catch ex As Exception

                    errorMessage = "送出パターンの作成に失敗しました。" & vbCrLf & vbCrLf & ex.Message

                End Try

            Case CommandEventArgs.Requests.CopyImage

                '=== 拡大画像をクリップボードへコピーする ===
                Try
                    Clipboard.SetImage(ImageScreen.Bmp)
                Catch ex As Exception
                    errorMessage = "拡大画像のコピーに失敗しました。" & vbCrLf & vbCrLf & ex.Message
                End Try

            Case Else

                errorMessage = "未知の要請を受けました。"

        End Select

        '--- 完了 ---
        If errorMessage <> "" Then
            MessageBox.Show(errorMessage, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            'System.Media.SystemSounds.Asterisk.Play() 'Beepと同じ音だった。やっぱり、ビープ音だと「了解」とか「完了」って感じがしないし、ちょっと五月蝿い。
            Sound(SIGNAL_COMPLETE) 'それでもやっぱり無音は寂しいので、Waveファイルがあれば再生するようにした。
        End If

    End Sub

    ''' <summary>
    ''' Waveファイルを再生する。
    ''' </summary>
    ''' <param name="path">Waveファイルのパス</param>
    ''' <remarks></remarks>
    Private Sub Sound(path As String)

        If IO.File.Exists(path) Then
            Try
                My.Computer.Audio.Play(path, AudioPlayMode.Background) 'BEEP音はダメだったけど、やっぱり無音は寂しいので、Waveファイルがあれば再生するようにした。
            Catch ex As Exception
                MessageBox.Show("Waveファイルが再生できませんでした。" & vbCrLf & IO.Path.GetFullPath(path) & vbCrLf & vbCrLf & ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If

    End Sub





    '|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||





    ''' <summary>
    ''' 色コードをARGBの各要素に分離する
    ''' </summary>
    ''' <param name="ColorCode">色コード(ARGB値)</param>
    ''' <returns>各色要素を収めた配列{A,R,G,B}</returns>
    ''' <remarks></remarks>
    Public Shared Function SplitARGB(ColorCode As Integer) As Byte()

        Dim argb(3) As Byte

        For i As Integer = 3 To 0 Step -1 'B→G→R→Aの順に処理する。
            argb(i) = ColorCode And &HFF 'カラーコードの下位1Byteを取り出す。
            ColorCode = ColorCode >> 8   'カラーコードを8bit(1Byte)右シフトする（色コードはInteger型なので算術シフトとなり符号ビットが残されるが、ここでの目的には影響しない）。
        Next

        Return argb

    End Function

    ''' <summary>
    ''' 色コードを色書式で表現する
    ''' </summary>
    ''' <param name="ColorCode">色コード(ARGB値)</param>
    ''' <param name="Format">色書式</param>
    ''' <returns>指定書式で表現された色コード文字列</returns>
    ''' <remarks></remarks>
    Public Shared Function GetColorString(ColorCode As Integer, Format As String) As String

        Try

            Dim ColorString As String

            Dim argb() As Byte = SplitARGB(ColorCode)
            Format = Format.Replace(vbCr, "").Replace(vbLf, vbCrLf) 'UTF-8（設定ファイルの文字コード）での改行コード"LF"を、Windowsの"CRLF"に置換する。
            ColorString = String.Format(Format, vbCrLf, ColorCode, ColorCode And &HFFFFFF, argb(0), argb(1), argb(2), argb(3), CSng(argb(0) / 255)) '{0}:改行, {1}:ARGB, {2}:RGB(A値なし), {3}:A, {4}:R, {5}:G, {6}:B, {7}:A(0.0F～1.0F)

            Return ColorString

        Catch ex As Exception

            Throw New ApplicationException("設定内容の複製に失敗しました。" & vbCrLf & "（" & ex.Message & "）") 'エラーは、呼び出し元へ返す。

        End Try

    End Function

End Class