﻿''' <summary>
''' 設定コンソール
''' </summary>
''' <remarks></remarks>
Public Class FormSetupConsole

    ''' <summary>更新間隔の1目盛り分</summary>
    Private Const ADJUST_INTERVAL As Integer = 50

    ''' <summary>改行の代替文字</summary>
    Private Const ENTER_STRING As String = "\n"



    '===========================================================================================================



    ''' <summary>お試し時のバックアップ用</summary>
    Private BackupSetting As SettingParameter = Nothing

    ''' <summary>入力したキーセット</summary>
    Private InputtedKey As Keys = Keys.None



    '===========================================================================================================



    Private Sub FormSetupConsole_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '=== 初期設定 ===
        Me.Icon = My.Resources.Main
        Me.Text = My.Application.Info.Title & Me.Text

        '--- 説明文の設定 ---
        '各コントロールのプロパティウィンドにあ《hlpEasyExplainのHelpString》では、改行を含む文章を編集できなかったので、ここで設定している。
        With hlpEasyExplain

            .SetHelpString(trkRefreshInterval, String.Format("拡大鏡を更新する間隔を、{0}ミリ秒単位で指定します。", ADJUST_INTERVAL))

            .SetHelpString(nudMagnification, "ピクセルを何倍に拡大するかを指定します。" & vbCrLf & "[ファンクション]キー（[F1]を除く）で、大まかに入力できます。")
            Dim commonMessage As String = "ビューの横幅を指定します。" & vbCrLf & String.Format("ただし、実際の最大値は、使用する画面の解像度に依存（作業領域の短辺の{0:P0}）するため、これを超える値（赤字）で確定しても、その寸法にはなりません。", FormMain_Viewer.VIEW_SIZE_MAXIMAM)
            .SetHelpString(nudViewWidth, commonMessage)
            .SetHelpString(nudViewHeight, commonMessage.Replace("横", "縦"))
            .SetHelpString(chkSquare, "縦と横を同じ値にする場合は、チェックを入れます。")
            .SetHelpString(btnFit, "現在の設定値以下で、""ビューからはみ出さず、注目点が中心に来る""最も大きい値に調整します。" & vbCrLf & "現在の入力値による視野の目安が、枠部に表示されています。")

            .SetHelpString(chkMark, "ビューに注目点を表示したい時に、チェックを入れます。")
            .SetHelpString(cbbMark, "マークの色を設定します。")
            .SetHelpString(chkSight, "注目点から縦横斜め方向を示したい時に、チェックを入れます。")
            .SetHelpString(cbbSight, "サイトの色を設定します。")
            .SetHelpString(chkGrid, "ピクセル間を区切る格子を表示したい時に、チェックを入れます。")
            .SetHelpString(cbbGrid, "格子の色を設定します。")
            .SetHelpString(chkPattern, "拡大画像の下地に模様を描画させたい時に、チェックを入れます。" & vbCrLf & "模様を描くことで、デスクトップの外側や壁紙の透明な部分を区別できます。")
            .SetHelpString(cbbPattern, "模様の色を設定します。")
            .SetHelpString(cbbFoundation, "下地の色を設定します。")

            .SetHelpString(nudDistance, """移動を始める"" または ""マウスカーソルとの間に保つ"" 距離を、画面(作業領域)の短辺に対する割合で指定します。" & vbCrLf & "上記の数値は、現在の使用画面で換算した参考値です。")
            .SetHelpString(chkCross, "マルチスクリーン環境で、画面間を越えて使いたい場合は、チェックを入れます。")
            .SetHelpString(cmbAvoidType, "拡大鏡がマウスカーソルを避ける方法を選択します。")

            .SetHelpString(cmbInfoPanelStyle, "情報パネルの形式を選択します。")
            .SetHelpString(btnFont, "使用するフォント（等幅のみ）を設定します。")

            .SetHelpString(chkCallKey, "コマンドパッド指呼キーを使用する時は、チェックを入れます。")
            .SetHelpString(chkDirectKey, "ダイレクトキーを使用する時は、チェックを入れます。")
            .SetHelpString(lvwOperationKey, "操作キーに使用するキーを設定します。" & vbCrLf & "ここで変更したい項目を選択してから、下の[" & btnInputKey.Text & "]をクリックしてください。")
            .SetHelpString(btnInputKey, "操作キーに使用するキーを入力します。" & vbCrLf & "上の一覧から選択した後、ここをクリックして望みのキーを押すと、その組み合わせが表示されます。もう一度マウスでクリックすると登録されます。" & vbCrLf & "登録する前に他の項目を選択すると、入力した内容が破棄されます。")

            .SetHelpString(cmbColorFormat, "コマンドパッドで色コードを取得する際の書式を設定します。" & vbCrLf & "既定の書式から選んだり、お好みの書式を入力したりできます。" & vbCrLf & "上側には、使用例が表示されます。改行は、""" & ENTER_STRING & """と表記されます。" & vbCrLf & vbCrLf & "書式は、《String.Format》メソッドに規準し、以下の要素を使用できます。" & vbCrLf & "　{0}=改行, {1}=ARGB, {2}=RGB" & vbCrLf & "　{3}=A, {4}=R, {5}=G, {6}=B, {7}=A(0.0F～1.0F)")

            .SetHelpString(btnDefault, "設定コンソールの表示内容や設定ファイルを初期化します。" & vbCrLf & "表示される質問に答えながら、作業を進めてください。")

            .SetHelpString(btnTry, "変更内容を適用した状態を確認できます。" & vbCrLf & "保存されないので、[" & btnCancel.Text & "]をクリックすれば元に戻ります。")
            .SetHelpString(btnOK, "変更内容を確定して保存します。")
            .SetHelpString(btnCancel, "変更を破棄して、設定を終了します。[" & btnTry.Text & "]中の場合は、元の設定に戻ります。")

        End With

        '--- 設定項目の基本設定 ---
        '情報パネル形式
        With cmbInfoPanelStyle
            .DisplayMember = "Caption"
            .ValueMember = "TypeID"
            .DataSource = FormInfoPanel_Base.PreparedLooks
        End With

        'マウスからの回避項目
        With cmbAvoidType
            .DisplayMember = "Caption"
            .ValueMember = "TypeID"
            .DataSource = Avoid_Base.PreparedActions
        End With

        '既製色書式とサンプル
        cmbColorFormat.Items.Clear()
        If SettingData.CommandPad.ColorFormat.Ready IsNot Nothing Then cmbColorFormat.Items.AddRange(SettingData.CommandPad.ColorFormat.Ready.ToArray)
        cmbColorFormat_TextChanged(cmbColorFormat, New EventArgs) '使用書式がデザイン時の《.Text》プロパティと同じだった場合に備えて、《.TextChanged》イベントのプロシージャを呼び出して、書式を取得する。お作法的には、別途プロシージャを設けるべきかも？

        '最大値を設定
        trkRefreshInterval.Maximum = FormMain_Viewer.REFRESH_INTERVAL_MAXIMUM \ ADJUST_INTERVAL
        nudViewWidth.Maximum = FormMain_Viewer.VIEW_ADJUST_MAXIMAM
        nudViewHeight.Maximum = FormMain_Viewer.VIEW_ADJUST_MAXIMAM
        nudMagnification.Maximum = FormMain_Viewer.MAGNIFICATION_MAXIMUM
        nudDistance.Maximum = FormMain_Viewer.NEAR_DISTANCE_MAXIMUM
        fdlgFontPicker.MaxSize = FormInfoPanel_Base.FONT_SIZE_MAXIMUM

        '現在の設定内容を表示
        DisplayParameter(SettingData)

        '最小値を設定
        trkRefreshInterval.Minimum = FormMain_Viewer.REFRESH_INTERVAL_MINIMUM \ ADJUST_INTERVAL
        nudViewWidth.Minimum = FormMain_Viewer.VIEW_ADJUST_MINIMUM
        nudViewHeight.Minimum = FormMain_Viewer.VIEW_ADJUST_MINIMUM
        nudMagnification.Minimum = FormMain_Viewer.MAGNIFICATION_MINIMUM
        nudDistance.Minimum = FormMain_Viewer.NEAR_DISTANCE_MINIMUM
        fdlgFontPicker.MinSize = FormInfoPanel_Base.FONT_SIZE_MINIMUM
        '設定項目によっては、最初に《ValueChanged》イベントを発生させないといけない物がある。
        'そのために、初期値をありえない数値(0)にしておいて、設定値を代入しイベントを発生させる。よって、最小値の設定を後回しにしている。
        '《NumericUpDown》コントロールは、最大値または最小値を変更すれば《ValueChanged》イベントが発生するが、《TrackBar》コントロールでは発生しないので、その対策としてこのような手順を踏んでいる。

    End Sub

    Private Sub btnDefault_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDefault.Click

        '=== 初期化 ===
        '--- 設定項目 ---
        Select Case MessageBox.Show("設定コンソールの表示内容のみを、既定値に戻しますか？", Me.Text, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button3)

            Case Windows.Forms.DialogResult.Yes

                DisplayParameter(New SettingParameter)

            Case Windows.Forms.DialogResult.No

                If MessageBox.Show("設定ファイルの全項目（設定コンソールにない項目も含む）を、既定値に戻しますか？" & vbCrLf & vbCrLf & "※注意：設定ファイルが書き換わり、現在の内容を完全に失います。", Me.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
                    Me.DialogResult = Windows.Forms.DialogResult.OK
                    SettingData = New SettingParameter
                    Save()
                End If

        End Select

    End Sub

    Private Sub btnTry_Click(sender As System.Object, e As System.EventArgs) Handles btnTry.Click

        '=== 設定の試用 ===
        Try

            If BackupSetting Is Nothing Then '初めての時だけ・・・
                BackupSetting = SettingData.Clone '現在の設定をバックアップ。
                btnTry.Text &= "*"
            End If

            Decision()
            DirectCast(Owner, FormMain_Viewer).AllNew()

        Catch ex As Exception

            MessageBox.Show("『" & btnTry.Text & "』に失敗しました。" & vbCrLf & vbCrLf & ex.Message, My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Error)
            btnTry.Enabled = False

        End Try

    End Sub

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click

        '=== 決定 ===
        Decision()
        Save()

    End Sub

    Private Sub btnCancel_Click(sender As Object, e As System.EventArgs) Handles btnCancel.Click

        '=== キャンセル ===
        If CheckTrying() Then
            '--- お試し中なら元に戻す ---
            SettingData = BackupSetting
            DirectCast(Owner, FormMain_Viewer).AllNew()
        End If

    End Sub

    Private Sub trkRefreshInterval_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles trkRefreshInterval.ValueChanged

        '=== 更新間隔 ===
        '更新間隔は、1ms単位で指定しても意味がなさそうなので、《SmallChange》プロパティで単位設定するのではなく計算で行っている。
        With grpRefresh
            trkRefreshInterval.Tag = trkRefreshInterval.Value * ADJUST_INTERVAL
            .Text = String.Format(.Tag, trkRefreshInterval.Tag)
        End With

    End Sub

    Private Sub nudMagnification_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles nudMagnification.KeyDown

        '=== 2^nの数値を倍率に与える ===
        Select Case e.KeyCode
            Case Keys.F2 To Keys.F24 '[Alt]+[Fx]キーで、[F1]キーから使用することも考えたけど、「2倍にどれほどの意味があるのか」「[F1]はヘルプで使用済み（[Alt]+[F1]ならヘルプが表示されない）」「2キー同時押しは面倒」を考えると、[F2]以降で十分事足りる。

                Dim x As Integer = 2 ^ (e.KeyCode - Keys.F1 + 1)
                x = Math.Max(x, nudMagnification.Minimum) '現在の下限値より小さい数字になることはないので、事実上不要な処理。
                x = Math.Min(x, nudMagnification.Maximum)
                nudMagnification.Value = x

                e.SuppressKeyPress = True

        End Select

    End Sub

    Private Sub nudMagnification_ValueChanged(sender As Object, e As System.EventArgs) Handles nudMagnification.ValueChanged

        '=== 調整単位を倍率値にする ===
        nudViewWidth.Increment = nudMagnification.Value
        nudViewHeight.Increment = nudViewWidth.Increment

        ShowFieldSize()

    End Sub

    Private Sub nudScreenSize_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudViewWidth.ValueChanged, nudViewHeight.ValueChanged

        '=== 正方形設定 ===
        If chkSquare.Checked Then _
            DirectCast(If(sender Is nudViewWidth, nudViewHeight, nudViewWidth), NumericUpDown).Value = DirectCast(sender, NumericUpDown).Value

        LimitChecker()
        ShowFieldSize()

    End Sub

    Private Sub chkSquare_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkSquare.CheckedChanged

        '=== 正方形設定の変更 ===
        If chkSquare.Checked Then
            If nudViewWidth.Value < nudViewHeight.Value Then
                nudViewHeight.Value = nudViewWidth.Value
            Else
                nudViewWidth.Value = nudViewHeight.Value
            End If
        End If

    End Sub

    Private Sub btnFit_Click(sender As System.Object, e As System.EventArgs) Handles btnFit.Click

        '=== 倍率に合わせて視野を調整する ===
        nudViewWidth.Value = Fitting(nudViewWidth.Value, nudViewWidth.Minimum)
        If Not chkSquare.Checked Then nudViewHeight.Value = Fitting(nudViewHeight.Value, nudViewHeight.Minimum)

    End Sub

    Private Sub ColorPickup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbbMark.Click, cbbSight.Click, cbbGrid.Click, cbbPattern.Click, cbbFoundation.Click

        '=== マーク / サイト / 格子線 / 下地 の色変更 ===
        With cdlgColorPicker
            Dim target As ColorBoxButton = sender '対象
            .Color = target.BoxColor
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                target.BoxColor = .Color
                If target Is cbbPattern Then cbbFoundation.SlashColor = .Color '下地斜線は、下地背景の色箱にも反映する。
            End If
        End With

    End Sub

    Private Sub nudDistance_ValueChanged(sender As Object, e As System.EventArgs) Handles nudDistance.ValueChanged

        '=== 回避距離の変更 ===
        Dim workArea As Rectangle = DirectCast(Owner, FormMain_Viewer).UsingScreen

        With grpAvoid
            .Text = String.Format(.Tag, CInt(Math.Min(workArea.Width, workArea.Height) / 100 * nudDistance.Value))
        End With

    End Sub

    Private Sub btnFont_Click(sender As System.Object, e As System.EventArgs) Handles btnFont.Click

        '=== フォントの選択 ===
        With fdlgFontPicker
            .Font = DirectCast(btnFont.Tag, Font)

            If .ShowDialog <> Windows.Forms.DialogResult.Cancel Then
                btnFont.Tag = .Font
            End If
        End With

    End Sub

    Private Sub lvwOperationKey_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles lvwOperationKey.SelectedIndexChanged

        '=== 対象を選択 ===
        btnInputKey.Enabled = (lvwOperationKey.SelectedItems.Count > 0)

    End Sub

    Private Sub btnInputKey_Enter(sender As System.Object, e As System.EventArgs) Handles btnInputKey.Enter

        '=== 入力開始 ===
        btnInputKey.Text = "受付中・・・"

        DirectCast(Owner, FormMain_Viewer).tmrOpeKeyScan.Enabled = False '操作キーを一時停止

    End Sub

    Private Sub btnInputKey_Leave(sender As System.Object, e As System.EventArgs) Handles btnInputKey.Leave

        '=== 入力中止 ===
        btnInputKey.Text = "入力"
        InputtedKey = Keys.None

        DirectCast(Owner, FormMain_Viewer).tmrOpeKeyScan.Enabled = True '操作キーを再開（入力に使用したキーに反応してしまうのが欠点）

    End Sub

    Private Sub btnInputKey_PreviewKeyDown(sender As Object, e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles btnInputKey.PreviewKeyDown

        '=== キー入力の有効化 ===
        'これ、すごく重要！！ [KeyDown]では通常受け取れないキー入力を、受け取れるようにする。その代わり、フォーカス移動やコピー・カット＆ペースト等の機能を失う。今回は好都合♪
        e.IsInputKey = True

    End Sub

    Private Sub btnInputKey_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles btnInputKey.KeyDown

        '[PreviewKeyDown]イベントでも、入力できない組み合わせがある（[Control]+[Alt]+[Up]等）。
        'これは、OS等で予約されてるからなのかも？

        Select Case e.KeyCode

            Case Keys.ShiftKey, Keys.ControlKey, Keys.Menu

                '=== 修飾子キーのみが押された時 ===
                InputtedKey = Keys.None

            Case Else

                '=== キーセット取得 ===
                InputtedKey = e.Modifiers Or e.KeyCode '修飾子キーフラグとキーコードを合成

        End Select

        btnInputKey.Text = GetString(InputtedKey)

        e.SuppressKeyPress = True

    End Sub

    Private Sub btnInputKey_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles btnInputKey.MouseClick
        '[Space]キー押下をクリックと混同しないように、マウスクリックのみに反応する。

        If InputtedKey <> Keys.None Then

            '=== 入力したキーを登録 ===
            With lvwOperationKey.SelectedItems(0)
                .Tag = InputtedKey
                .SubItems(1).Text = GetString(InputtedKey)
            End With

        End If

    End Sub

    Private Sub cmbColorFormat_TextChanged(sender As System.Object, e As System.EventArgs) Handles cmbColorFormat.TextChanged

        '=== 色書式サンプルを表示 ===
        With grpColorFormat
            Try
                Dim colorCode As String = FormMain_Viewer.GetColorString(&HAA112233, cmbColorFormat.Text)
                colorCode = If(colorCode = "", "無効", colorCode.Replace("&", "&&").Replace(vbCrLf, ENTER_STRING)) '結果を整形する。 → 空文字なら無効に / "&"を表示可能に / 改行文字を代替文字列に
                .Text = String.Format(.Tag, colorCode)
                .ForeColor = SystemColors.ControlText
            Catch ex As Exception
                .Text = String.Format(.Tag, "不正書式")
                .ForeColor = Color.Red
            End Try
        End With

    End Sub

    ''' <summary>
    ''' 現在の設定内容を表示する
    ''' </summary>
    ''' <param name="Parameters">表示するパラメータ</param>
    ''' <remarks></remarks>
    Private Sub DisplayParameter(ByVal Parameters As SettingParameter)

        With Parameters

            '=== 拡大鏡 ===
            With .Lupe

                '--- 更新間隔 ---
                trkRefreshInterval.Value = .RefreshInterval \ ADJUST_INTERVAL

                '--- ビューア ---
                With .Viewer

                    '拡大
                    nudMagnification.Value = .Magnification

                    With .ViewSize
                        nudViewWidth.Value = .Width
                        nudViewHeight.Value = .Height
                        chkSquare.Checked = (nudViewWidth.Value = nudViewHeight.Value) '縦横同じ値が選択されていたら、正方形設定にする。
                    End With

                    'ガイド
                    chkMark.Checked = .Mark.Enabled
                    cbbMark.BoxColor = .Mark.MainColor

                    chkSight.Checked = .Sight.Enabled
                    cbbSight.BoxColor = .Sight.MainColor

                    chkGrid.Checked = .Grid.Enabled
                    cbbGrid.BoxColor = .Grid.MainColor

                    chkPattern.Checked = .Foundation.Enabled
                    cbbPattern.BoxColor = .Foundation.SubColor
                    cbbFoundation.BoxColor = .Foundation.MainColor
                    cbbFoundation.SlashColor = .Foundation.SubColor

                End With

                '--- マウスからの回避 ---
                With .Avoid
                    cmbAvoidType.SelectedValue = .Type
                    chkCross.Checked = .Cross
                    nudDistance.Value = .ExerciseDistance
                End With

                'chkCross.Enabled = (Screen.AllScreens.Length > 1)

                '--- 情報パネルの形式 ---
                With .InformationPanel
                    cmbInfoPanelStyle.SelectedValue = .Style
                    btnFont.Tag = .Font.GetFont
                End With

            End With

            '=== 操作キー ===
            With .OperationKey

                '--- スイッチ類 ---
                chkCallKey.Checked = .ComPadCallKeyEnabled
                chkDirectKey.Checked = .DirectKeyEnabled

                '--- 割り当てキー ---
                Dim caption() As String = New String() {"コマンドパッド指呼", "カーソル上", "カーソル下", "カーソル左", "カーソル右", "ビュー撮影"},
                    key() As Keys = New Keys() {.ComPadCallKeys, .DirectKeys.CursorUpKey, .DirectKeys.CursorDownKey, .DirectKeys.CursorLeftKey, .DirectKeys.CursorRightKey, .DirectKeys.CaptureKey}
                Dim newItem(caption.GetUpperBound(0)) As ListViewItem

                For i As Integer = newItem.GetLowerBound(0) To newItem.GetUpperBound(0)
                    newItem(i) = New ListViewItem(New String() {caption(i), GetString(key(i))}) With {.Tag = key(i)} '《ToolTipText》プロパティを設定しなくても、はみ出しテキストは自動的に表示してくれるみたい。
                Next

                With lvwOperationKey
                    .Items.Clear()
                    .Items.AddRange(newItem)
                    .Items(0).BackColor = Color.Snow 'コマンドパッド指呼キーは、厳密にはダイレクトキーではないので色を変えておく。
                End With

            End With

            '=== コマンドパッド ===
            '--- 色書式 ---
            cmbColorFormat.Text = .CommandPad.ColorFormat.Using

        End With

    End Sub

    ''' <summary>
    ''' 入力値が理論限界を超えているか確認する
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub LimitChecker()

        '=== ビュー寸法 ===
        With DirectCast(Owner, FormMain_Viewer)
            nudViewWidth.ForeColor = If(nudViewWidth.Value <= .ViewSizeUpperLimit, SystemColors.WindowText, Color.Red)
            nudViewHeight.ForeColor = If(nudViewHeight.Value <= .ViewSizeUpperLimit, SystemColors.WindowText, Color.Red)
        End With

    End Sub

    ''' <summary>
    ''' 視野の目安を表示する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowFieldSize()

        With grpMagnify
            .Text = String.Format(.Tag, nudViewWidth.Value / nudMagnification.Value, nudViewHeight.Value / nudMagnification.Value)
        End With

    End Sub

    ''' <summary>
    ''' 現在の倍率で綺麗に収まるビューサイズを求める
    ''' </summary>
    ''' <param name="Value">現在の縦または横の値</param>
    ''' <param name="Minimum">設定可能な最小値</param>
    ''' <returns>調整した値</returns>
    ''' <remarks></remarks>
    Private Function Fitting(Value As Integer, Minimum As Integer) As Integer

        Value = Math.Min(Value, DirectCast(Owner, FormMain_Viewer).ViewSizeUpperLimit) \ nudMagnification.Value
        Value += -1 + (Value Mod 2)
        Value = Math.Max(Value * nudMagnification.Value, Minimum)
        Return Value

    End Function

    ''' <summary>
    ''' キーセットを文字列に変換する
    ''' </summary>
    ''' <param name="Keyset">キーセット</param>
    ''' <returns></returns>
    ''' <remarks>[ToString]メソッドでは、綺麗な順番で得られないため</remarks>
    Private Function GetString(Keyset As Keys) As String

        Dim result As String = ""

        If (Keyset And Keys.Shift) = Keys.Shift Then result &= "[Shift] + "
        If (Keyset And Keys.Control) = Keys.Control Then result &= "[Control] + "
        If (Keyset And Keys.Alt) = Keys.Alt Then result &= "[Alt] + "

        result &= "[" & (Keyset And Keys.KeyCode).ToString & "]"

        Return result

    End Function

    ''' <summary>
    ''' 設定値を確定する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Decision()

        With SettingData

            '=== 拡大鏡 ===
            With .Lupe

                '--- 更新間隔 ---
                .RefreshInterval = CInt(trkRefreshInterval.Tag)

                '--- ビューア ---
                With .Viewer

                    '拡大
                    .Magnification = nudMagnification.Value
                    .ViewSize = New Size(nudViewWidth.Value, nudViewHeight.Value)

                    'ガイド
                    .Mark.Enabled = chkMark.Checked
                    .Mark.MainColor = cbbMark.BoxColor

                    .Sight.Enabled = chkSight.Checked
                    .Sight.MainColor = cbbSight.BoxColor

                    .Grid.Enabled = chkGrid.Checked
                    .Grid.MainColor = cbbGrid.BoxColor

                    .Foundation.Enabled = chkPattern.Checked
                    .Foundation.MainColor = cbbFoundation.BoxColor
                    .Foundation.SubColor = cbbFoundation.SlashColor

                End With

                '--- マウスからの逃避 ---
                With .Avoid
                    .Type = cmbAvoidType.SelectedValue
                    .Cross = chkCross.Checked
                    .ExerciseDistance = nudDistance.Value
                End With

                '--- 情報パネル ---
                With .InformationPanel
                    .Style = cmbInfoPanelStyle.SelectedValue
                    .Font.SetFont(btnFont.Tag)
                End With

            End With

            '=== 操作キー ===
            With .OperationKey

                '--- スイッチ類 ---
                .ComPadCallKeyEnabled = chkCallKey.Checked
                .DirectKeyEnabled = chkDirectKey.Checked

                '--- 割り当てキー ---
                .ComPadCallKeys = lvwOperationKey.Items(0).Tag

                With .DirectKeys
                    .CursorUpKey = lvwOperationKey.Items(1).Tag
                    .CursorDownKey = lvwOperationKey.Items(2).Tag
                    .CursorLeftKey = lvwOperationKey.Items(3).Tag
                    .CursorRightKey = lvwOperationKey.Items(4).Tag
                    .CaptureKey = lvwOperationKey.Items(5).Tag
                End With

            End With

            '=== コマンドパッド ===
            '--- 色書式 ---
            .CommandPad.ColorFormat.Using = cmbColorFormat.Text

        End With

    End Sub

    ''' <summary>
    ''' 設定内容を保存する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Save()

        Try

            Windows.Forms.Cursor.Current = Cursors.WaitCursor 'ほとんど処理時間掛からないから要らないけど、おまけ。
            'Throw New Exception("テスト") 'テスト用にエラーを発生させてみる。
            SettingSave()

        Catch ex As Exception

            MessageBox.Show("設定ファイルの保存中に例外が発生しました。" & vbCrLf & vbCrLf & ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.DialogResult = Windows.Forms.DialogResult.None '終了を取り消す

        End Try

    End Sub

    ''' <summary>
    ''' 現在、お試し中か調べる
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function CheckTrying() As Boolean

        Return (BackupSetting IsNot Nothing)

    End Function

End Class