﻿''' <summary>
''' 情報パネル ～ 派生クラス：若あゆ
''' </summary>
''' <remarks></remarks>
Public Class FormInfoPanel_Bar

    Inherits FormInfoPanel_Base

    Protected Overrides Sub LabelArrange()

        '=== 表示位置設定 ===
        Me.SuspendLayout()

        LabelDisposition(lblAlpha)
        LabelDisposition(lblRed, lblAlpha, ContentAlignment.MiddleRight)
        LabelDisposition(lblGreen, lblRed, ContentAlignment.MiddleRight)
        LabelDisposition(lblBlue, lblGreen, ContentAlignment.MiddleRight)
        LabelDisposition(lblMath, lblAlpha, ContentAlignment.BottomCenter, , 1)
        LabelDisposition(lblLocate, lblMath, ContentAlignment.MiddleRight, 1)
        LabelDisposition(lblRelative, lblLocate, ContentAlignment.TopRight, -lblRelative.Width) '自分の横幅を引いて、右端をそろえる。

        Me.ResumeLayout()

    End Sub

    Public Overrides Sub PrintParameter(Locate As Point, ColorCode As Integer)

        '=== 情報表示 ===
        Dim argbFormat As String = "{0:X2}({0:d3})"
        Dim argb() As Byte = FormMain_Viewer.SplitARGB(ColorCode)
        lblAlpha.Text = String.Format(argbFormat, argb(0))
        lblRed.Text = String.Format(argbFormat, argb(1))
        lblGreen.Text = String.Format(argbFormat, argb(2))
        lblBlue.Text = String.Format(argbFormat, argb(3))

        Dim home As Point = Screen.GetBounds(Windows.Forms.Cursor.Position).Location '現在マウスカーソルがある画面の左上座標を取得する。
        lblLocate.Text = String.Format("({0,5:D4},{1,5:D4}){2,5:D4},{3,5:D4}", Locate.X, Locate.Y, Locate.X - home.X, Locate.Y - home.Y)

        Dim distance As Double = GetDistance_P2P(ResumeData.CardinalPoint, Locate)
        Dim angle As Double = GetAngle(ResumeData.CardinalPoint, Locate) '※注意※ これ以降《locate》は相対座標！！
        lblMath.Text = String.Format("{0,8:##0.0000}°{1,9:###0.0000}", Math.Round(angle, 4, MidpointRounding.AwayFromZero), Math.Round(distance, 4, MidpointRounding.AwayFromZero))

        lblRelative.Text = String.Format("{0,5:+###0;-###0;0},{1,5:+###0;-###0;0}", Locate.X, Locate.Y)

    End Sub

End Class
