﻿''' <summary>
''' 情報パネル ～ 派生クラス：みたらし団子
''' </summary>
''' <remarks></remarks>
Public Class FormInfoPanel_Full

    Inherits FormInfoPanel_Base

    Protected Overrides Sub LabelArrange()

        '=== 表示位置設定 ===
        Me.SuspendLayout()

        LabelDisposition(lblAlpha)
        LabelDisposition(lblRed, lblAlpha, ContentAlignment.MiddleRight)
        LabelDisposition(lblGreen, lblRed, ContentAlignment.MiddleRight)
        LabelDisposition(lblBlue, lblGreen, ContentAlignment.MiddleRight)
        LabelDisposition(lblMath, lblAlpha, ContentAlignment.BottomCenter, , 1)
        LabelDisposition(lblLocate, lblMath, ContentAlignment.BottomCenter, , 1)
        LabelDisposition(lblRelative, lblLocate, ContentAlignment.MiddleRight, 1)

        Me.ResumeLayout()

    End Sub

    Public Overrides Sub PrintParameter(Locate As System.Drawing.Point, ColorCode As Integer)

        '=== 情報表示 ===
        Dim argbFormat As String = "{0:X2}({0:d3})"
        Dim argb() As Byte = FormMain_Viewer.SplitARGB(ColorCode), tempColor As Color
        With lblAlpha
            tempColor = Color.FromArgb(argb(0), argb(0), argb(0))
            .Text = String.Format(argbFormat, argb(0))
            .BackColor = tempColor
            .ForeColor = If(tempColor.GetBrightness < 0.65, Color.White, Color.Black)
        End With
        With lblRed
            tempColor = Color.FromArgb(argb(1), 0, 0)
            .Text = String.Format(argbFormat, argb(1))
            .BackColor = tempColor
        End With
        With lblGreen
            tempColor = Color.FromArgb(0, argb(2), 0)
            .Text = String.Format(argbFormat, argb(2))
            .BackColor = tempColor
            .ForeColor = If(tempColor.GetBrightness < 0.38, Color.White, Color.Black)
        End With
        With lblBlue
            tempColor = Color.FromArgb(0, 0, argb(3))
            .Text = String.Format(argbFormat, argb(3))
            .BackColor = tempColor
        End With

        Dim home As Point = Screen.GetBounds(Windows.Forms.Cursor.Position).Location '現在マウスカーソルがある画面の左上座標を取得する。
        lblLocate.Text = String.Format("({1,5:D4},{2,5:D4}){0} {3,5:D4},{4,5:D4}", vbCrLf, Locate.X, Locate.Y, Locate.X - home.X, Locate.Y - home.Y)

        Dim distance As Double = GetDistance_P2P(ResumeData.CardinalPoint, Locate)
        Dim angle As Double = GetAngle(ResumeData.CardinalPoint, Locate) '※注意※ これ以降《locate》は相対座標！！
        lblMath.Text = String.Format("{0,16:###0.00000000000}°{1,16:###0.00000000000}", angle, distance) '《String.Format》の桁数指定による丸めは、四捨五入になるみたい。

        lblRelative.Text = String.Format(" {1,5:+###0;-###0;0},{2,5:+###0;-###0;0}{0}({3,5:D4},{4,5:D4})", vbCrLf, Locate.X, Locate.Y, ResumeData.CardinalPoint.X, ResumeData.CardinalPoint.Y)

    End Sub

End Class
