﻿''' <summary>
''' 情報パネル ～ 派生クラス：きんつば
''' </summary>
''' <remarks></remarks>
Public Class FormInfoPanel_Square

    Inherits FormInfoPanel_Base

    Public Sub New()

        '=== 不要項目の整理 ===
        'Me.Controls.Remove(lblAlpha) '不要だった。
        lblAlpha.Dispose() 'この解放だけで、コントロールコレクション《Me.Controls》からも削除される。

    End Sub

    Protected Overrides Sub LabelArrange()

        '=== 表示位置設定 ===
        Me.SuspendLayout()

        LabelDisposition(lblRed)
        LabelDisposition(lblGreen, lblRed, ContentAlignment.BottomCenter)
        LabelDisposition(lblBlue, lblGreen, ContentAlignment.BottomCenter)
        LabelDisposition(lblLocate, lblRed, ContentAlignment.MiddleRight, 1)
        LabelDisposition(lblRelative, lblLocate, ContentAlignment.BottomCenter)
        LabelDisposition(lblMath, lblRelative, ContentAlignment.BottomCenter)

        Me.ResumeLayout()

    End Sub

    Public Overrides Sub PrintParameter(Locate As Point, ColorCode As Integer)

        '=== 情報表示 ===
        Dim argbFormat As String = "{0:X2}={0:d3}"
        Dim argb() As Byte = FormMain_Viewer.SplitARGB(ColorCode)
        lblRed.Text = String.Format(argbFormat, argb(1))
        lblGreen.Text = String.Format(argbFormat, argb(2))
        lblBlue.Text = String.Format(argbFormat, argb(3))

        lblLocate.Text = String.Format("{0,5:D4},{1,5:D4}", Locate.X, Locate.Y)

        Dim distance As Double = GetDistance_P2P(ResumeData.CardinalPoint, Locate)
        Dim angle As Double = GetAngle(ResumeData.CardinalPoint, Locate) '※注意※ これ以降《locate》は相対座標！！ 
        lblMath.Text = String.Format("{0,3}°  {1,4}", Math.Round(angle, 0, MidpointRounding.AwayFromZero), Math.Round(distance, 0, MidpointRounding.AwayFromZero))

        lblRelative.Text = String.Format("{0,5:+###0;-###0;0},{1,5:+###0;-###0;0}", Locate.X, Locate.Y)

    End Sub

End Class
