﻿''' <summary>
''' 情報パネル ～ 派生クラス：八つ橋
''' </summary>
''' <remarks></remarks>
Public Class FormInfoPanel_Twig

    Inherits FormInfoPanel_Base

    Public Sub New()

        '=== 不要項目の整理 ===
        lblRed.Dispose()
        lblGreen.Dispose()
        lblBlue.Dispose()
        lblLocate.Dispose()
        lblMath.Dispose()

        '=== 枠・背面有り加工 ===
        '注目点の色がフォームの背景色（透過対象の色）と同じ場合、ラベルも透けてしまうので、フォームを透明にできない。
        Me.BackColor = SystemColors.Control
        Me.TransparencyKey = Nothing
        Me.FormBorderStyle = Windows.Forms.FormBorderStyle.FixedToolWindow
        Me.Padding = New Padding(1)

    End Sub

    Protected Overrides Sub LabelArrange()

        '=== 表示位置設定 ===
        Me.SuspendLayout()

        LabelDisposition(lblAlpha, , , 1, 1) 'カラーコードの表示に《lblAlpha》を流用する。
        LabelDisposition(lblRelative, lblAlpha, ContentAlignment.MiddleRight)

        Me.ResumeLayout()

    End Sub

    Public Overrides Sub PrintParameter(Locate As Point, ColorCode As Integer)

        '=== 情報表示 ===
        Dim tempColor As Color = Color.FromArgb(ColorCode)
        With lblAlpha
            .Text = String.Format("{0:X8}", ColorCode)
            .BackColor = tempColor
            .ForeColor = If(tempColor.GetBrightness < 0.5, Color.White, Color.Black) '背景色の明るさによって前景色を切り替える。色によっては見難い場合もあるけど、簡単なのでこの方法を取った。
        End With

        Locate = CovertLocate(ResumeData.CardinalPoint, Locate)
        lblRelative.Text = String.Format("{0,5:+###0;-###0;0},{1,5:+###0;-###0;0}", Locate.X, Locate.Y)

    End Sub

End Class
