﻿'┌────┐
'│技術要綱├──────────────────────
'└┬───┘
'  │『使い方』
'  │1.ソリューション エクスプローラの [すべてのファイルを表示] を有効にし、目的のフォームのサブファイルを展開して "～.Designer.vb" を開く。
'  │2.そこの冒頭にある、 "Inherits System.Windows.Forms.Form" を "Inherits UnProtrudeForm" に書き換える。
'  │3.改めてビルドすると、デザイナーを開けられるようになる。※ビルドしないで開くとエラーになる。
'  └────────────





''' <summary>
''' 領域内からはみ出さないようにできるフォーム
''' </summary>
''' <remarks></remarks>
Public Class UnProtrudeForm

    Inherits Form



    '===========================================================================================================



    ''' <summary>
    ''' ある領域内からはみ出さないように補正する。
    ''' </summary>
    ''' <param name="Locate">表示位置</param>
    ''' <param name="ObjectSize">寸法</param>
    ''' <param name="LimitArea">制限領域</param>
    ''' <returns>補正された位置</returns>
    ''' <remarks></remarks>
    Public Function UnProtrude(Locate As Point, ObjectSize As Size, LimitArea As Rectangle) As Point

        Return New Point(Math.Min(Math.Max(LimitArea.Left, Locate.X), LimitArea.Right - ObjectSize.Width),
                         Math.Min(Math.Max(LimitArea.Top, Locate.Y), LimitArea.Bottom - ObjectSize.Height))

    End Function

    ''' <summary>
    ''' ある領域内からはみ出さないように移動する。
    ''' </summary>
    ''' <param name="NewLocate">移動先</param>
    ''' <param name="LimitArea">制限領域</param>
    ''' <remarks></remarks>
    Public Overridable Sub UnProtrudeRepositioner(NewLocate As Point, LimitArea As Rectangle)

        Me.Location = UnProtrude(NewLocate, Me.Size, LimitArea)

    End Sub

    ''' <summary>
    ''' ある領域内からはみ出さないように位置を修正する。
    ''' </summary>
    ''' <param name="LimitArea">制限領域</param>
    ''' <remarks></remarks>
    Public Overridable Sub UnProtrudeRepositioner(LimitArea As Rectangle)

        Me.Location = UnProtrude(Me.Location, Me.Size, LimitArea)

    End Sub

End Class
